"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useAnimationOnScroll = void 0;
var react_1 = require("react");
function useAnimationOnScroll(params) {
    var ref = params.ref, animate = params.animate, setAnimationProps = params.setAnimationProps, rootMargin = params.rootMargin;
    var observe = function () {
        if (!ref.current) {
            return;
        }
        var observer = new IntersectionObserver(function (entries) {
            if (!entries[0].isIntersecting) {
                return;
            }
            setAnimationProps(animate);
            observer.unobserve(entries[0].target);
        }, { rootMargin: rootMargin });
        observer.observe(ref.current);
    };
    react_1.useEffect(function () {
        observe();
    }, []);
}
exports.useAnimationOnScroll = useAnimationOnScroll;
//# sourceMappingURL=useAnimationOnScroll.js.map