"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GlArticle = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var theme_1 = require("./theme");
var theme_2 = require("./theme");
var react_markdown_1 = __importDefault(require("react-markdown"));
var GlButton_1 = require("./utils/GlButton");
var GlAnimatedOnScroll_1 = require("./GlAnimatedOnScroll");
var useStyles = theme_1.makeStyles()(function (theme, _a) {
    var illustrationPosition = _a.illustrationPosition, hasIllustration = _a.hasIllustration, hasArticle = _a.hasArticle;
    return ({
        "root": __assign({}, theme.spacing.rightLeft("padding", theme.paddingRightLeft + "px")),
        "contentWrapper": __assign(__assign({ "display": "flex", "flexDirection": (function () {
                if (illustrationPosition === "left" &&
                    theme.windowInnerWidth >= theme_2.breakpointsValues.md) {
                    return "row-reverse";
                }
                if (theme.windowInnerWidth < theme_2.breakpointsValues.md) {
                    return "column";
                }
                return undefined;
            })(), "alignItems": theme.windowInnerWidth < theme_2.breakpointsValues.md ? "left" : "center", "justifyContent": "center" }, (function () {
            var value = theme.spacing(7);
            return {
                "marginTop": value,
                "marginBottom": value,
            };
        })()), (function () {
            var value = theme.spacing(8);
            if (theme.windowInnerWidth < theme_2.breakpointsValues.lg || !hasArticle) {
                return undefined;
            }
            if (illustrationPosition === "left") {
                return {
                    "paddingRight": value,
                };
            }
            return {
                "paddingLeft": value,
            };
        })()),
        "article": __assign({ "display": "flex", "flexDirection": "column", "textAlign": "left", "marginBottom": (function () {
                if (theme.windowInnerWidth >= theme_2.breakpointsValues.md ||
                    !hasIllustration) {
                    return undefined;
                }
                return theme.spacing(8);
            })(), "width": (function () {
                if (!hasIllustration) {
                    return undefined;
                }
                if (theme.windowInnerWidth >= theme_2.breakpointsValues.xl) {
                    return 412;
                }
                if (theme.windowInnerWidth >= theme_2.breakpointsValues["lg+"]) {
                    return 311;
                }
                if (theme.windowInnerWidth >= theme_2.breakpointsValues.md) {
                    return 270;
                }
                return undefined;
            })() }, (function () {
            var value = theme.windowInnerWidth >= theme_2.breakpointsValues.lg
                ? theme.spacing(9)
                : theme.spacing(5);
            if (theme.windowInnerWidth < theme_2.breakpointsValues.md ||
                !hasIllustration) {
                return undefined;
            }
            if (illustrationPosition === "left") {
                return {
                    "marginLeft": value,
                };
            }
            return {
                "marginRight": value,
            };
        })()),
        "body": __assign(__assign({}, theme.typography.variants["body 1"].style), { "margin": theme.spacing({
                "topBottom": 4,
                "rightLeft": 0,
            }), "color": theme.colors.useCases.typography.textSecondary }),
        "buttonWrapper": {
            "display": "flex",
            "justifyContent": "flex-end",
        },
        "button": {
            "alignSelf": "right",
        },
        "aside": __assign({}, (theme.windowInnerWidth >= theme_2.breakpointsValues.md
            ? __assign(__assign({}, (function () {
                if (!hasArticle) {
                    return undefined;
                }
                var value = theme.spacing(8);
                switch (illustrationPosition) {
                    case "left":
                        return {
                            "marginRight": value,
                        };
                    case "right":
                        return {
                            "marginLeft": value,
                        };
                }
            })()), { "maxWidth": 800 }) : {})),
    });
});
exports.GlArticle = react_1.memo(function (props) {
    var illustration = props.illustration, body = props.body, buttonLabel = props.buttonLabel, illustrationPosition = props.illustrationPosition, title = props.title, className = props.className, id = props.id, buttonLink = props.buttonLink, hasAnimation = props.hasAnimation;
    var _a = useStyles({
        "illustrationPosition": illustrationPosition !== null && illustrationPosition !== void 0 ? illustrationPosition : "right",
        "hasIllustration": illustration !== undefined,
        "hasArticle": title !== undefined ||
            body !== undefined ||
            buttonLabel !== undefined,
    }), classes = _a.classes, cx = _a.cx;
    var getAnimationProps = react_1.useMemo(function () {
        return function (params) {
            var componentToAnimate = params.componentToAnimate;
            if (!hasAnimation) {
                return {};
            }
            var textTransitionParameters = {
                "ease": "easeOut",
                "duration": 0.5,
                "delay": 0.3,
            };
            switch (componentToAnimate) {
                case "body":
                    return {
                        "initial": {
                            "opacity": 0,
                        },
                        "animate": {
                            "opacity": 1,
                        },
                        "transition": textTransitionParameters,
                    };
                case "title":
                    return {
                        "initial": {
                            "opacity": 0,
                            "x": (function () {
                                var value = 100;
                                switch (illustrationPosition) {
                                    case "left":
                                        return value;
                                    default:
                                        return -value;
                                }
                            })(),
                        },
                        "animate": {
                            "opacity": 1,
                            "x": 0,
                        },
                        "transition": textTransitionParameters,
                    };
                case "illustration":
                    return {
                        "initial": {
                            "rotateY": "15deg",
                            "rotateX": "15deg",
                        },
                        "animate": {
                            "rotateY": 0,
                            "rotateX": 0,
                        },
                        "transition": {
                            "delay": 1,
                            "duration": 1,
                            "ease": "easeOut",
                        },
                    };
            }
        };
    }, []);
    return (jsx_runtime_1.jsx("section", __assign({ id: id, className: cx(classes.root, className) }, { children: jsx_runtime_1.jsxs("div", __assign({ className: classes.contentWrapper }, { children: [(title !== undefined ||
                    body !== undefined ||
                    buttonLabel !== undefined) && (jsx_runtime_1.jsxs("article", __assign({ className: classes.article }, { children: [title && (jsx_runtime_1.jsx(GlAnimatedOnScroll_1.GlAnimatedOnScroll, __assign({}, getAnimationProps({
                            "componentToAnimate": "title",
                        }), { children: jsx_runtime_1.jsx(theme_1.Text, __assign({ typo: "page heading" }, { children: title }), void 0) }), void 0)),
                        body && (jsx_runtime_1.jsx(GlAnimatedOnScroll_1.GlAnimatedOnScroll, __assign({}, getAnimationProps({
                            "componentToAnimate": "body",
                        }), { children: jsx_runtime_1.jsx(react_markdown_1.default, __assign({ className: classes.body }, { children: body }), void 0) }), void 0)),
                        buttonLabel && (jsx_runtime_1.jsx("div", __assign({ className: classes.buttonWrapper }, { children: jsx_runtime_1.jsx(GlButton_1.GlButton, __assign({ className: classes.button, type: "submit", href: buttonLink === null || buttonLink === void 0 ? void 0 : buttonLink.href, onClick: buttonLink === null || buttonLink === void 0 ? void 0 : buttonLink.onClick, variant: "secondary" }, { children: buttonLabel }), void 0) }), void 0))] }), void 0)),
                jsx_runtime_1.jsx(GlAnimatedOnScroll_1.GlAnimatedOnScroll, __assign({}, getAnimationProps({
                    "componentToAnimate": "illustration",
                }), { children: jsx_runtime_1.jsx("aside", __assign({ className: classes.aside }, { children: illustration }), void 0) }), void 0)] }), void 0) }), void 0));
});
//# sourceMappingURL=GlArticle.js.map