"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GlSectionDivider = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var theme_1 = require("./theme");
var useStyles = theme_1.makeStyles()(function (theme) { return ({
    "root": {
        "display": "flex",
        "justifyContent": "center",
    },
    "primary": {
        "position": "relative",
        "backgroundColor": theme.colors.useCases.typography.textTertiary,
        "height": 1,
        "width": "60%",
        "margin": theme.spacing({
            "topBottom": 7,
            "rightLeft": 0,
        }),
    },
    "secondary": {
        "position": "relative",
        "height": 1,
        "width": "60%",
        "margin": theme.spacing({
            "topBottom": 7,
            "rightLeft": 0,
        }),
        ":before": {
            "content": "\"\"",
            "position": "absolute",
            "top": 0,
            "left": "5%",
            "width": "90%",
            "height": 1,
            "background": "linear-gradient(to right, transparent, " + theme.colors.useCases.typography.textTertiary + ", transparent)",
        },
    },
}); });
exports.GlSectionDivider = react_1.memo(function (props) {
    var className = props.className, variant = props.variant;
    var _a = useStyles(), classes = _a.classes, cx = _a.cx;
    return (jsx_runtime_1.jsx("div", __assign({ className: classes.root }, { children: jsx_runtime_1.jsx("div", { className: cx(variant === "secondary"
                ? classes.secondary
                : classes.primary, className) }, void 0) }), void 0));
});
//# sourceMappingURL=GlSectionDivider.js.map