/// <reference types="react" />
export declare const ThemeProviderDefault: (props: import("onyxia-ui").ThemeProviderProps) => JSX.Element;
export declare function useTheme(): {
    paddingRightLeft: number;
    colors: {
        palette: {
            focus: {
                main: string;
                light: string;
                light2: string;
            };
            dark: {
                main: string;
                light: string;
                greyVariant1: string;
                greyVariant2: string;
                greyVariant3: string;
                greyVariant4: string;
            };
            light: {
                main: string;
                light: string;
                greyVariant1: string;
                greyVariant2: string;
                greyVariant3: string;
                greyVariant4: string;
            };
            redError: {
                main: string;
                light: string;
            };
            greenSuccess: {
                main: string;
                light: string;
            };
            orangeWarning: {
                main: string;
                light: string;
            };
            blueInfo: {
                main: string;
                light: string;
            };
        };
        useCases: {
            typography: {
                textPrimary: string;
                textSecondary: string;
                textTertiary: string;
                textDisabled: string;
                textFocus: string;
            };
            buttons: {
                actionHoverPrimary: string;
                actionHoverSecondary: string;
                actionHoverTernary: string;
                actionSelected: string;
                actionActive: string;
                actionDisabled: string;
                actionDisabledBackground: string;
            };
            surfaces: {
                background: string;
                surface1: string;
                surface2: string;
            };
            alertSeverity: {
                error: {
                    main: string;
                    background: string;
                };
                success: {
                    main: string;
                    background: string;
                };
                warning: {
                    main: string;
                    background: string;
                };
                info: {
                    main: string;
                    background: string;
                };
            };
        };
    };
    isDarkModeEnabled: boolean;
    typography: import("onyxia-ui").ComputedTypography<never>;
    shadows: readonly ["none", "0px 6px 10px 0px rgba(0,0,0,0.07)", "0px 4px 4px 0px rgba(0,0,0,0.1)", "6px 0px 16px 0px rgba(0,0,0,0.15)", "4px 0px 10px 0px rgba(0,0,0,0.07)", "-4px 0px 10px 0px rgba(0,0,0,0.07)", "0px 6px 10px 0px rgba(0,0,0,0.14)", "0px 8px 10px -7px rgba(0,0,0,0.07)"];
    spacing: import("onyxia-ui").Spacing;
    muiTheme: import("@material-ui/core").Theme;
    custom: Record<string, unknown>;
    iconSizesInPxByName: Record<"small" | "medium" | "default" | "large" | "extra small", number>;
    windowInnerWidth: number;
};
export declare const makeStyles: <Params = void>() => <Key extends string>(getCssObjectOrCssObject: Record<Key, import("tss-react").CSSObject> | ((theme: {
    paddingRightLeft: number;
    colors: {
        palette: {
            focus: {
                main: string;
                light: string;
                light2: string;
            };
            dark: {
                main: string;
                light: string;
                greyVariant1: string;
                greyVariant2: string;
                greyVariant3: string;
                greyVariant4: string;
            };
            light: {
                main: string;
                light: string;
                greyVariant1: string;
                greyVariant2: string;
                greyVariant3: string;
                greyVariant4: string;
            };
            redError: {
                main: string;
                light: string;
            };
            greenSuccess: {
                main: string;
                light: string;
            };
            orangeWarning: {
                main: string;
                light: string;
            };
            blueInfo: {
                main: string;
                light: string;
            };
        };
        useCases: {
            typography: {
                textPrimary: string;
                textSecondary: string;
                textTertiary: string;
                textDisabled: string;
                textFocus: string;
            };
            buttons: {
                actionHoverPrimary: string;
                actionHoverSecondary: string;
                actionHoverTernary: string;
                actionSelected: string;
                actionActive: string;
                actionDisabled: string;
                actionDisabledBackground: string;
            };
            surfaces: {
                background: string;
                surface1: string;
                surface2: string;
            };
            alertSeverity: {
                error: {
                    main: string;
                    background: string;
                };
                success: {
                    main: string;
                    background: string;
                };
                warning: {
                    main: string;
                    background: string;
                };
                info: {
                    main: string;
                    background: string;
                };
            };
        };
    };
    isDarkModeEnabled: boolean;
    typography: import("onyxia-ui").ComputedTypography<never>;
    shadows: readonly ["none", "0px 6px 10px 0px rgba(0,0,0,0.07)", "0px 4px 4px 0px rgba(0,0,0,0.1)", "6px 0px 16px 0px rgba(0,0,0,0.15)", "4px 0px 10px 0px rgba(0,0,0,0.07)", "-4px 0px 10px 0px rgba(0,0,0,0.07)", "0px 6px 10px 0px rgba(0,0,0,0.14)", "0px 8px 10px -7px rgba(0,0,0,0.07)"];
    spacing: import("onyxia-ui").Spacing;
    muiTheme: import("@material-ui/core").Theme;
    custom: Record<string, unknown>;
    iconSizesInPxByName: Record<"small" | "medium" | "default" | "large" | "extra small", number>;
    windowInnerWidth: number;
}, params: Params, createRef: () => string) => Record<Key, import("tss-react").CSSObject>)) => (params: Params) => {
    classes: Record<Key, string>;
    theme: {
        paddingRightLeft: number;
        colors: {
            palette: {
                focus: {
                    main: string;
                    light: string;
                    light2: string;
                };
                dark: {
                    main: string;
                    light: string;
                    greyVariant1: string;
                    greyVariant2: string;
                    greyVariant3: string;
                    greyVariant4: string;
                };
                light: {
                    main: string;
                    light: string;
                    greyVariant1: string;
                    greyVariant2: string;
                    greyVariant3: string;
                    greyVariant4: string;
                };
                redError: {
                    main: string;
                    light: string;
                };
                greenSuccess: {
                    main: string;
                    light: string;
                };
                orangeWarning: {
                    main: string;
                    light: string;
                };
                blueInfo: {
                    main: string;
                    light: string;
                };
            };
            useCases: {
                typography: {
                    textPrimary: string;
                    textSecondary: string;
                    textTertiary: string;
                    textDisabled: string;
                    textFocus: string;
                };
                buttons: {
                    actionHoverPrimary: string;
                    actionHoverSecondary: string;
                    actionHoverTernary: string;
                    actionSelected: string;
                    actionActive: string;
                    actionDisabled: string;
                    actionDisabledBackground: string;
                };
                surfaces: {
                    background: string;
                    surface1: string;
                    surface2: string;
                };
                alertSeverity: {
                    error: {
                        main: string;
                        background: string;
                    };
                    success: {
                        main: string;
                        background: string;
                    };
                    warning: {
                        main: string;
                        background: string;
                    };
                    info: {
                        main: string;
                        background: string;
                    };
                };
            };
        };
        isDarkModeEnabled: boolean;
        typography: import("onyxia-ui").ComputedTypography<never>;
        shadows: readonly ["none", "0px 6px 10px 0px rgba(0,0,0,0.07)", "0px 4px 4px 0px rgba(0,0,0,0.1)", "6px 0px 16px 0px rgba(0,0,0,0.15)", "4px 0px 10px 0px rgba(0,0,0,0.07)", "-4px 0px 10px 0px rgba(0,0,0,0.07)", "0px 6px 10px 0px rgba(0,0,0,0.14)", "0px 8px 10px -7px rgba(0,0,0,0.07)"];
        spacing: import("onyxia-ui").Spacing;
        muiTheme: import("@material-ui/core").Theme;
        custom: Record<string, unknown>;
        iconSizesInPxByName: Record<"small" | "medium" | "default" | "large" | "extra small", number>;
        windowInnerWidth: number;
    };
    css: import("tss-react").Css;
    cx: import("tss-react").Cx;
};
export declare const Text: import("react").MemoExoticComponent<import("react").ForwardRefExoticComponent<{
    className?: string | null | undefined;
    typo: import("onyxia-ui").TypographyDesc.VariantNameBase;
    color?: "disabled" | "focus" | "primary" | "secondary" | undefined;
    children: boolean | import("react").ReactChild | import("react").ReactFragment | import("react").ReactPortal;
    htmlComponent?: import("onyxia-ui").TypographyDesc.HtmlComponent | undefined;
    componentProps?: import("react").DetailedHTMLProps<import("react").AnchorHTMLAttributes<HTMLAnchorElement>, HTMLAnchorElement> | import("react").DetailedHTMLProps<import("react").HTMLAttributes<HTMLDivElement>, HTMLDivElement> | import("react").DetailedHTMLProps<import("react").HTMLAttributes<HTMLHeadingElement>, HTMLHeadingElement> | import("react").DetailedHTMLProps<import("react").HTMLAttributes<HTMLParagraphElement>, HTMLParagraphElement> | import("react").DetailedHTMLProps<import("react").HTMLAttributes<HTMLSpanElement>, HTMLSpanElement> | undefined;
} & import("react").RefAttributes<any>>>;
export declare const Icon: import("react").MemoExoticComponent<import("react").ForwardRefExoticComponent<import("onyxia-ui/Icon").IconProps<"brightness4" | "brightness7" | "arrowBackIos" | "arrowForwardIos" | "dehaze" | "brightness1Rounded"> & import("react").RefAttributes<SVGSVGElement>>>;
export declare const IconButton: import("react").MemoExoticComponent<import("react").ForwardRefExoticComponent<import("onyxia-ui/IconButton").IconButtonProps<"brightness4" | "brightness7" | "arrowBackIos" | "arrowForwardIos" | "dehaze" | "brightness1Rounded"> & import("react").RefAttributes<HTMLButtonElement>>>;
export declare const Button: import("react").MemoExoticComponent<import("react").ForwardRefExoticComponent<import("onyxia-ui/Button").ButtonProps<"brightness4" | "brightness7" | "arrowBackIos" | "arrowForwardIos" | "dehaze" | "brightness1Rounded"> & import("react").RefAttributes<HTMLButtonElement>>>;
export declare const breakpointsValues: {
    "lg+": 1440;
    sm: 600;
    md: 960;
    lg: 1280;
    xl: 1920;
};
